<?php

require_once 'php/config.php';
require_once 'php/db.php';
require_once 'php/delta.php';

$sql = "CREATE TABLE " . TABLES_PREFIX . "categories (
id bigint(20) unsigned NOT NULL AUTO_INCREMENT,
name text,
PRIMARY KEY  (id)
);";
delta($sql);

$sql = "CREATE TABLE " . TABLES_PREFIX . "flags (
id bigint(20) unsigned NOT NULL AUTO_INCREMENT,
user_id int(11) NOT NULL,
post_id int(11) NOT NULL,
reason text,
date timestamp NULL DEFAULT NULL,
PRIMARY KEY  (id)
);";
delta($sql);

$sql = "CREATE TABLE " . TABLES_PREFIX . "likes (
id bigint(20) unsigned NOT NULL AUTO_INCREMENT,
post_id int(11) NOT NULL,
user_id int(11) NOT NULL,
PRIMARY KEY  (id)
);";
delta($sql);

$sql = "CREATE TABLE " . TABLES_PREFIX . "posts (
id bigint(20) unsigned NOT NULL AUTO_INCREMENT,
title text,
body text NOT NULL,
user_id int(11) NOT NULL,
category_id int(11) NOT NULL,
parent_id int(11) DEFAULT NULL,
likes int(11) DEFAULT NULL,
is_question varchar(1) NOT NULL,
flagged varchar(1) NOT NULL,
date timestamp NULL DEFAULT NULL,
views bigint(20) NOT NULL DEFAULT '0',
last_edited_on timestamp NULL DEFAULT NULL,
last_edited_by int(11) DEFAULT NULL,
locked varchar(1) NOT NULL DEFAULT 'n',
PRIMARY KEY  (id)
);";
delta($sql);

$sql = "CREATE TABLE " . TABLES_PREFIX . "posts_following (
id bigint(20) unsigned NOT NULL AUTO_INCREMENT,
user_id int(11) NOT NULL,
post_id int(11) NOT NULL,
PRIMARY KEY  (id)
);";
delta($sql);

$sql = "CREATE TABLE " . TABLES_PREFIX . "users (
id bigint(20) unsigned NOT NULL AUTO_INCREMENT,
username text NOT NULL,
email text NOT NULL,
password text NOT NULL,
status varchar(10) NOT NULL,
likes int(11) DEFAULT NULL,
role varchar(10) NOT NULL,
notes text,
hash text,
photo text,
bio text,
PRIMARY KEY  (id)
);";
delta($sql);

