<?php

require 'includes.php';

if(!Users_IsUserLoggedIn()){
	Leave('index.php');
}

$layout = GetPage('profiles', '{{ST:profile}}');

$layout->AddContentById('breadcrumbs', ' <li><a href="index.php">{{ST:home}}</a> <span class="divider">/</span> </li><li class="active">{{ST:profiles}}</li>');

if(isset($_GET['id'])){
	$id = intval($_GET['id']);
}else{
	Leave('index.php');
}

$admin = $db->get_row("SELECT * FROM " . TABLES_PREFIX . "users WHERE id = $id ORDER BY id DESC LIMIT 0,1");

if(isset($_GET['delete_photo']) AND intval($_GET['delete_photo']) == 1){
	if($admin->photo){
		$db->update(TABLES_PREFIX . "users", array('photo'=>''), array('id'=>$id), array("%s"));
		$file = $admin->photo;
		$exists = file_exists($file);
		if($exists){
			unlink($file);
			Leave('profiles.php?id='.$id.'&message=image_deleted');
		}else{
			$layout->AddContentById('alert', $layout->GetContent('alert'));
			$layout->AddContentById('alert_nature', ' alert-error');
			$layout->AddContentById('alert_heading', '{{ST:error}}!');
			$layout->AddContentById('alert_message', '{{ST:image_does_not_exist}}');
		}
	}else{
		$layout->AddContentById('alert', $layout->GetContent('alert'));
		$layout->AddContentById('alert_nature', ' alert-error');
		$layout->AddContentById('alert_heading', '{{ST:error}}!');
		$layout->AddContentById('alert_message', '{{ST:image_does_not_exist}}');
	}
}

if(isset($_GET['message']) AND $_GET['message'] != ''){
	
	if($_GET['message'] == 'image_deleted'){
		$layout->AddContentById('alert', $layout->GetContent('alert'));
		$layout->AddContentById('alert_nature', ' alert-success');
		$layout->AddContentById('alert_heading', '{{ST:success}}!');
		$layout->AddContentById('alert_message', '{{ST:the_image_has_been_deleted}}');
	}
}

$layout->AddContentById('username', $admin->username);
$layout->AddContentById('bio', $admin->bio);
if($admin->photo){
	$layout->AddContentById('photo', $admin->photo);
	if(Users_IsUserAdmin(Users_CurrentUserId())){
		$layout->AddContentById('delete_photo', '<p><a onclick="return confirm(\'{{ST:are_you_sure}}\');" title="{{ST:delete}}" href="profiles.php?id='.$id.'&delete_photo=1">{{ST:delete}}</a></p>');
	}
}else{
	$layout->AddContentById('photo', 'img/anon.png');
}



$layout->AddContentById('threads_started', count($db->get_results("SELECT * FROM " . TABLES_PREFIX . "posts WHERE is_question = 'y'" )));
$layout->AddContentById('total_posts', count($db->get_results("SELECT * FROM " . TABLES_PREFIX . "posts" )));

$layout->RenderViewAndExit();
