<?php

require 'includes.php';

if(isset($_GET['id'])){
	$id = intval($_GET['id']);
}else{
	Leave('index.php');
}

$question = $db->get_row("SELECT * FROM " . TABLES_PREFIX . "posts WHERE id = $id ORDER BY id DESC LIMIT 0,1");


$layout = GetPage('thread', '{{ST:thread}}');

$layout->AddContentById('breadcrumbs', ' <li><a href="index.php">{{ST:home}}</a> <span class="divider">/</span> <li><a href="index.php?id='.$question->category_id.'">'.$db->get_var("SELECT name FROM " . TABLES_PREFIX . "categories WHERE id = " . intval($question->category_id)).'</a> <span class="divider">/</span> </li><li class="active">{{ST:thread}}</li>');

if(isset($_GET['lock']) AND intval($_GET['lock']) == 1){
	if(Users_IsUserAdmin(Users_CurrentUserId())){
		$db->update(TABLES_PREFIX . "posts", array('locked'=>'y'), array('id'=>$id), array("%s"));
		$layout->AddContentById('alert', $layout->GetContent('alert'));
		$layout->AddContentById('alert_nature', ' alert-success');
		$layout->AddContentById('alert_heading', '{{ST:success}}!');
		$layout->AddContentById('alert_message', '{{ST:the_thread_has_been_locked}}');
		$question = $db->get_row("SELECT * FROM " . TABLES_PREFIX . "posts WHERE id = $id ORDER BY id DESC LIMIT 0,1");
	}
}

if(isset($_GET['unlock']) AND intval($_GET['unlock']) == 1){
	if(Users_IsUserAdmin(Users_CurrentUserId())){
		$db->update(TABLES_PREFIX . "posts", array('locked'=>'n'), array('id'=>$id), array("%s"));
		$layout->AddContentById('alert', $layout->GetContent('alert'));
		$layout->AddContentById('alert_nature', ' alert-success');
		$layout->AddContentById('alert_heading', '{{ST:success}}!');
		$layout->AddContentById('alert_message', '{{ST:the_thread_has_been_unlocked}}');
		$question = $db->get_row("SELECT * FROM " . TABLES_PREFIX . "posts WHERE id = $id ORDER BY id DESC LIMIT 0,1");
	}
}

if(isset($_GET['subscribe']) AND intval($_GET['subscribe']) == 1){
	if(Users_CurrentUserId()){
		$db->insert(TABLES_PREFIX . "posts_following", array('post_id'=>$id,'user_id'=>intval(Users_CurrentUserId())), array("%d","%d"));
		$layout->AddContentById('alert', $layout->GetContent('alert'));
		$layout->AddContentById('alert_nature', ' alert-success');
		$layout->AddContentById('alert_heading', '{{ST:success}}!');
		$layout->AddContentById('alert_message', '{{ST:you_have_subscribed_to_this_thread}}');
	}
}

if(isset($_GET['unsubscribe']) AND intval($_GET['unsubscribe']) == 1){
	if(Users_CurrentUserId()){
		$db->query("DELETE FROM " . TABLES_PREFIX . "posts_following WHERE post_id = " . $id . " AND user_id = " . intval(Users_CurrentUserId()));
		$layout->AddContentById('alert', $layout->GetContent('alert'));
		$layout->AddContentById('alert_nature', ' alert-success');
		$layout->AddContentById('alert_heading', '{{ST:success}}!');
		$layout->AddContentById('alert_message', '{{ST:you_have_unsubscribed_from_this_thread}}');
	}
}

if(isset($_GET['like']) AND intval($_GET['like']) == 1 AND isset($_GET['post'])){
	if(Users_CurrentUserId()){
		if(count($db->get_results("SELECT * FROM " . TABLES_PREFIX . "likes WHERE user_id = ".intval(Users_CurrentUserId())." AND post_id = ".intval($_GET['id'])."" )) > 0){
		
		}else{
			$db->insert(TABLES_PREFIX . "likes", array('post_id'=>intval($_GET['post']),'user_id'=>intval(Users_CurrentUserId())), array("%d","%d"));
			
			$the_post = $db->get_row("SELECT * FROM " . TABLES_PREFIX . "posts WHERE id = " .intval($_GET['post']) . " ORDER BY id DESC LIMIT 0,1");
			$db->update(TABLES_PREFIX . "posts", array('likes'=>(1+$the_post->likes)), array('id'=>intval($_GET['post'])), array("%d"));
			
			$layout->AddContentById('alert', $layout->GetContent('alert'));
			$layout->AddContentById('alert_nature', ' alert-success');
			$layout->AddContentById('alert_heading', '{{ST:success}}!');
			$layout->AddContentById('alert_message', '{{ST:you_have_liked_the_post}}');
		}
	}
}

if(isset($_GET['delete']) AND intval($_GET['delete']) == 1 AND isset($_GET['post'])){
	if(Users_IsUserAdmin(Users_CurrentUserId())){
		$the_post = $db->get_row("SELECT * FROM " . TABLES_PREFIX . "posts WHERE id = " .intval($_GET['post']) . " ORDER BY id DESC LIMIT 0,1");
		
		if($the_post->is_question == 'y'){
			$all_children = $db->get_results("SELECT * FROM " . TABLES_PREFIX . "posts WHERE id = ".intval($_GET['post'])." OR parent_id = ".intval($_GET['post'])."" );
			if($all_children){
				foreach($all_children as $child){
					$db->query("DELETE FROM " . TABLES_PREFIX . "posts_following WHERE post_id = " . intval($child->id) );
					$db->query("DELETE FROM " . TABLES_PREFIX . "likes WHERE post_id = " . intval($child->id));
					$db->query("DELETE FROM " . TABLES_PREFIX . "flags WHERE post_id = " . intval($child->id));
					$db->query("DELETE FROM " . TABLES_PREFIX . "posts WHERE id = " . intval($child->id));	
				}
			}
			Leave('index.php?message=deleted');
		}else{
			$db->query("DELETE FROM " . TABLES_PREFIX . "posts_following WHERE post_id = " . intval($_GET['post']) );
			$db->query("DELETE FROM " . TABLES_PREFIX . "likes WHERE post_id = " . intval($_GET['post']));
			$db->query("DELETE FROM " . TABLES_PREFIX . "flags WHERE post_id = " . intval($_GET['post']));
			$db->query("DELETE FROM " . TABLES_PREFIX . "posts WHERE id = " . intval($_GET['post']));
			
			$layout->AddContentById('alert', $layout->GetContent('alert'));
			$layout->AddContentById('alert_nature', ' alert-success');
			$layout->AddContentById('alert_heading', '{{ST:success}}!');
			$layout->AddContentById('alert_message', '{{ST:the_post_has_been_deleted}}');
		}
	}
}

if(isset($_GET['flag']) AND intval($_GET['flag']) == 1 AND isset($_GET['post'])){
	if(Users_CurrentUserId()){
		$db->insert(TABLES_PREFIX . "flags", array('post_id'=>intval($_GET['post']),'user_id'=>intval(Users_CurrentUserId()),'date'=>date('Y-m-d H:i:s')), array("%d","%d","%s"));
			
		$db->update(TABLES_PREFIX . "posts", array('flagged'=>'y'), array('id'=>intval($_GET['post'])), array("%s"));
			
		$layout->AddContentById('alert', $layout->GetContent('alert'));
		$layout->AddContentById('alert_nature', ' alert-success');
		$layout->AddContentById('alert_heading', '{{ST:success}}!');
		$layout->AddContentById('alert_message', '{{ST:the_post_has_been_flagged}}');
	}
}


if($question->locked == 'y'){
	$layout->AddContentById('post_title',  '({{ST:locked}})' . $question->title);
}else{
	$layout->AddContentById('post_title', $question->title);
}

if(!Users_IsUserLoggedIn()){
	$layout->AddContentById('post_alert', 'onclick="return SignInAlert();"');
}elseif($question->locked == 'y'){
	$layout->AddContentById('post_alert', 'onclick="return LockedAlert();"');
}

if(Users_IsUserAdmin(Users_CurrentUserId())){
	if($question->locked == 'y'){
		$layout->AddContentById('lock_state', 'style="display:none"');
	}else{
		$layout->AddContentById('unlock_state', 'style="display:none"');
	}
}else{
	$layout->AddContentById('unlock_state', 'style="display:none"');
	$layout->AddContentById('lock_state', 'style="display:none"');
}

if(!Users_IsUserLoggedIn()){
	$layout->AddContentById('subscribe_state', 'style="display:none"');
	$layout->AddContentById('unsubscribe_state', 'style="display:none"');
}else{
	if(count($db->get_results("SELECT * FROM " . TABLES_PREFIX . "posts_following WHERE user_id = ".intval(Users_CurrentUserId())." AND post_id = ".intval($_GET['id'])."" )) > 0){
		$layout->AddContentById('subscribe_state', 'style="display:none"');
	}else{
		$layout->AddContentById('unsubscribe_state', 'style="display:none"');
	}
}

if(!Users_IsUserAdmin(Users_CurrentUserId())){
	$layout->AddContentById('delete_state', 'style="display:none"');
}


$rows = ROWS_PER_PAGE;
$number_of_records = count($db->get_results("SELECT * FROM " . TABLES_PREFIX . "posts WHERE id = ".intval($_GET['id'])." OR parent_id = ".intval($_GET['id'])."" ));
$number_of_pages = ceil( $number_of_records / $rows );
if(isset($_GET['lastpage'])){
	$page = $number_of_pages;
}else{
	if(isset($_GET['page'])){
		$page = intval($_GET['page']);
	}else{
		$page = 1;
	}
}
$offset = ($page - 1) * $rows;
$layout->AddContentById('id', $question->id);
$layout->AddContentById('page', $page);

$latest = $db->get_results("SELECT * FROM " . TABLES_PREFIX . "posts WHERE id = ".intval($_GET['id'])." OR parent_id = ".intval($_GET['id'])." ORDER BY date ASC LIMIT $offset, $rows");


$rows_html = '';
if($latest){
	foreach($latest as $post){
		if($post->flagged == 'y'){
			$row_layout = new Layout('html/','str/');
			$row_layout->SetContentView('thread-flagged');
		}else{
			$row_layout = new Layout('html/','str/');
			$row_layout->SetContentView('thread-rows');
			$row_layout->AddContentById('id', $post->id);
			$row_layout->AddContentById('thread_id', $question->id);
			$row_layout->AddContentById('page', $page);
		
		
			$row_layout->AddContentById('question', preg_replace('/\v+|\\\[rn]/','<br/>',$post->body));
		
			$row_layout->AddContentById('likes', NiceNumber($post->likes));
		
			$row_layout->AddContentById('date', getRelativeTime($post->date));
		
			if(Users_IsUserAdmin($post->user_id)){
				$row_layout->AddContentById('is_admin', '<p><span class="label label-warning">{{ST:is_admin}}</span></p>');
			}
			$row_layout->AddContentById('user_id', $post->user_id);
		
			$user_details = Users_GetUserDetails($post->user_id);
			if($user_details){
				if($user_details['username']){
					$row_layout->AddContentById('user_name', $user_details['username']);
				}
				if($user_details['path_to_profile']){
					$row_layout->AddContentById('path_to_profile', $user_details['path_to_profile']);
				}
				if($user_details['path_to_photo']){
					$row_layout->AddContentById('user_photo', $user_details['path_to_photo']);
				}else{
					$row_layout->AddContentById('user_photo', 'img/anon.png');
				}	
			}
		
			if(!Users_IsUserAdmin(Users_CurrentUserId())){
				if(Users_CurrentUserId() != intval($post->user_id)){
					$row_layout->AddContentById('edit_state', 'style="display:none"');
				}
			}
		
			if(!Users_IsUserAdmin(Users_CurrentUserId())){
				$row_layout->AddContentById('delete_state', 'style="display:none"');
			}
		
			if(!Users_IsUserLoggedIn()){
				$row_layout->AddContentById('like_alert', 'onclick="return SignInAlert();"');
				$row_layout->AddContentById('flag_alert', 'onclick="return SignInAlert();"');
			}elseif(count($db->get_results("SELECT * FROM " . TABLES_PREFIX . "likes WHERE user_id = ".intval(Users_CurrentUserId())." AND post_id = ".intval($_GET['id'])."" )) > 0){
				$row_layout->AddContentById('like_alert', 'onclick="return CantLikeTwiceAlert();"');
				$row_layout->AddContentById('flag_alert', 'onclick="return confirm(\'{{ST:are_you_sure}}\');"');
			}
		
		}
		
		$rows_html .= $row_layout-> ReturnView();
	}
	
	if($number_of_records>$rows){
		$pagination = Paginate('thread.php?id='.intval($_GET['id']), $page, $number_of_pages, true, 3);
		$layout->AddContentById('pagination', $pagination);
	}
	
}else{
	$rows_html = '<p>{{ST:there_are_no_posts}}</p>';
}



$layout->AddContentById('rows', $rows_html);
$db->update(TABLES_PREFIX . "posts", array('views'=>(1+$question->views)), array('id'=>$id), array("%d"));
$layout->RenderViewAndExit();
